import java.applet.Applet;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.ImageObserver;

public class AnimateCanvas2 extends Canvas implements Runnable {
   Image osImage;
   Graphics osg;
   Image[] images;
   int currImage;
   int delayTime;
   int speed;
   Thread theThread;
   boolean started = false;
   boolean inDelay = false;
   int pauseTime;
   Color bkColor;
   Image bkImage;

   public AnimateCanvas2(Applet var1, int var2) {
      this.GetParameters(var1, var2);
   }

   void GetParameters(Applet var1, int var2) {
      String var3 = var1.getParameter("animateSpeed" + var2);
      this.speed = AppletParam2.GetInt(var3, 500);
      this.delayTime = this.speed;
      var3 = var1.getParameter("animatePauseTime" + var2);
      this.pauseTime = AppletParam2.GetInt(var3, 500);
      var3 = var1.getParameter("animateImageList" + var2);
      if (var3 != null) {
         var3 = var1.getParameter("animateImageStrip" + var2);
         boolean var4 = AppletParam2.GetBoolean(var3, false);
         if (var4) {
            var3 = var1.getParameter("animateImageWidth" + var2);
            int var5 = AppletParam2.GetInt(var3, 100);
            var3 = var1.getParameter("animateImageList" + var2);
            this.images = AppletParam2.GetImageStrip(var1, var3, var5);
         } else {
            var3 = var1.getParameter("animateImageList" + var2);
            this.images = AppletParam2.GetImageList(var1, var3);
         }
      }

      var3 = var1.getParameter("animateBkColor" + var2);
      this.bkColor = AppletParam2.GetColor(var3, (Color)null);
      if (this.bkColor != null) {
         ((Component)this).setBackground(this.bkColor);
      }

      var3 = var1.getParameter("animateBkImage" + var2);
      this.bkImage = var1.getImage(var1.getCodeBase(), var3);
   }

   public void run() {
      while(true) {
         if (this.theThread.isAlive()) {
            try {
               ((Component)this).repaint();
               if (this.currImage == this.images.length - 1) {
                  this.currImage = 0;
               } else {
                  ++this.currImage;
               }

               if (this.currImage == 0) {
                  Thread.sleep((long)this.pauseTime);
               } else {
                  Thread.sleep((long)this.speed);
               }
            } catch (InterruptedException var1) {
            }
         }
      }
   }

   public void update(Graphics var1) {
      if (this.osImage == null) {
         this.osImage = ((Component)this).createImage(((Component)this).size().width, ((Component)this).size().height);
         this.osg = this.osImage.getGraphics();
      }

      this.osg.setColor(((Component)this).getBackground());
      this.osg.fillRect(0, 0, ((Component)this).size().width, ((Component)this).size().height);
      if (this.bkImage != null) {
         int var2 = this.bkImage.getWidth(this);
         int var3 = this.bkImage.getHeight(this);
         int var4 = ((Component)this).size().width / var2;
         int var5 = ((Component)this).size().height / var3;
         ++var4;
         ++var5;

         for(int var6 = 0; var6 < var5; ++var6) {
            for(int var7 = 0; var7 < var4; ++var7) {
               this.osg.drawImage(this.bkImage, var7 * var2, var6 * var3, this);
            }
         }
      }

      if (this.images != null && this.images.length > 0 && this.images[this.currImage] != null) {
         this.osg.drawImage(this.images[this.currImage], 0, 0, ((Component)this).size().width, ((Component)this).size().height, this);
      }

      var1.drawImage(this.osImage, 0, 0, (ImageObserver)null);
   }

   public void Start() {
      this.theThread = new Thread(this);
      this.theThread.start();
   }

   public void Stop() {
      this.theThread.stop();
      this.theThread = null;
   }

   public synchronized void reshape(int var1, int var2, int var3, int var4) {
      super.reshape(var1, var2, var3, var4);
      this.osImage = null;
      this.osg = null;
   }

   public Dimension minimumSize() {
      return new Dimension(10, 10);
   }

   public Dimension preferredSize() {
      return new Dimension(10, 10);
   }
}
