import java.applet.Applet;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

public class HatchBorderPanel2 extends StaticBorderPanel2 {
   boolean hatchBorder;
   Color hatchColor;

   public HatchBorderPanel2(Applet var1, int var2) {
      this.GetParameters(var1, var2);
   }

   void GetParameters(Applet var1, int var2) {
      String var3 = var1.getParameter("hatchBorderThickness" + var2);
      ((BorderPanel2)this).SetThickness(AppletParam2.GetInt(var3, 5));
      var3 = var1.getParameter("hatchBorderBkColor" + var2);
      ((BorderPanel2)this).SetBackgroundColor(AppletParam2.GetColor(var3, Color.lightGray));
      var3 = var1.getParameter("hatchBorderBkImage" + var2);
      ((BorderPanel2)this).SetBackgroundImage(AppletParam2.GetImage(var1, var3));
      var3 = var1.getParameter("hatchBorderColor" + var2);
      this.SetHatchColor(AppletParam2.GetColor(var3, Color.black));
      var3 = var1.getParameter("hatchBorderShowBorder" + var2);
      this.SetHatchBorder(AppletParam2.GetBoolean(var3, false));
   }

   public void SetHatchBorder(boolean var1) {
      this.hatchBorder = var1;
   }

   public void SetHatchColor(Color var1) {
      this.hatchColor = var1;
   }

   void DoPaint(Graphics var1) {
      if (this.hatchColor != null) {
         var1.setColor(this.hatchColor);
      } else {
         var1.setColor(Color.black);
      }

      if (this.hatchBorder) {
         var1.drawRect(0, 0, ((Component)this).size().width - 1, ((Component)this).size().height - 1);
         var1.drawRect(super.thickness - 1, super.thickness - 1, ((Component)this).size().width - 2 * super.thickness, ((Component)this).size().height - 2 * super.thickness);
      }

      for(int var2 = 0; var2 < ((Component)this).size().width; var2 += super.thickness) {
         var1.drawLine(var2, 0, var2 + super.thickness - 1, super.thickness - 1);
         var1.drawLine(var2 + super.thickness - 1, 0, var2, super.thickness - 1);
         var1.drawLine(var2, ((Component)this).size().height - super.thickness - 1, var2 + super.thickness - 1, ((Component)this).size().height - 1);
         var1.drawLine(var2 + super.thickness - 1, ((Component)this).size().height - super.thickness - 1, var2, ((Component)this).size().height - 1);
      }

      for(int var3 = super.thickness; var3 < ((Component)this).size().height - super.thickness; var3 += super.thickness) {
         var1.drawLine(0, var3, super.thickness - 1, var3 + super.thickness - 1);
         var1.drawLine(super.thickness - 1, var3, 0, var3 + super.thickness - 1);
         var1.drawLine(((Component)this).size().width - super.thickness, var3, ((Component)this).size().width - 1, var3 + super.thickness - 1);
         var1.drawLine(((Component)this).size().width - 1, var3, ((Component)this).size().width - super.thickness - 1, var3 + super.thickness - 1);
      }

   }

   void DoResize(int var1, int var2) {
   }
}
